%{?mingw_package_header}

%define with_vss 1
%define qemu_version 3.1.0-rc0

Name: mingw-qemu-ga-win
Version: 100.0.0.0
Release: 3%{?dist}
Summary: Qemu's Guest agent for Windows

Group: System Environment/Daemons
License: GPLv2+ and LGPLv2+ and BSD
URL: http://www.qemu.org/
Requires(post): system-units
Requires(preun): systemd-units
Requires(postun): systemd-units
Source0: http://wiki.qemu.org/download/qemu-3.1.0-rc0.tar.bz2
Source1: build_configure.sh
%if %{with_vss}
Source2: VSSSDK72.tar.gz
%endif

Patch0001: 0001-qga-win-Handle-VSS_E_PROVIDER_ALREADY_REGISTERED-err.patch
Patch0002: 0001-qga-Installer-Wait-for-installation-to-finish.patch
Patch0003: 0001-Revert-osdep-Work-around-MinGW-assert.patch
Patch0004: 0001-Revert-qemu-ga-add-missing-libpcre-to-MSI-build.patch
Patch0005: 0001-qga-win-Adding-support-for-Windows-Server-2019-get-o.patch
Patch0006: 0001-qga-win-prevent-crash-when-executing-guest-file-read.patch
Patch0007: 0002-qga-fix-send_response-error-handling.patch
Patch0008: 0001-qga-fix-vendor-strings.patch
Patch0009: 0001-Change-VERSION-to-100.0.0.patch

BuildArch: noarch

BuildRequires: automake
BuildRequires: autoconf
BuildRequires: libtool
BuildRequires: SDL-devel zlib-devel which texi2html gnutls-devel cyrus-sasl-devel
BuildRequires: glib2-devel
BuildRequires: gtk2-devel
BuildRequires: systemd
BuildRequires: python
BuildRequires: systemtap-sdt-devel
BuildRequires: perl-podlators
BuildRequires: texinfo
BuildRequires: gettext
BuildRequires: gettext-devel
BuildRequires: mingw32-pixman
BuildRequires: mingw64-pixman
BuildRequires: mingw32-gcc
BuildRequires: mingw64-gcc
BuildRequires: mingw32-pkg-config
BuildRequires: mingw64-pkg-config
BuildRequires: mingw32-glib2
BuildRequires: mingw64-glib2
BuildRequires: mingw32-glib2-static
BuildRequires: mingw64-glib2-static
BuildRequires: mingw32-gettext-static
BuildRequires: mingw64-gettext-static
BuildRequires: mingw32-winpthreads-static
BuildRequires: mingw64-winpthreads-static
BuildRequires: mingw64-zlib-static
BuildRequires: mingw32-zlib-static
BuildRequires: mingw64-headers
BuildRequires: mingw32-headers
BuildRequires: msitools >= 0.93.93

%description
qemu-kvm is an open source virtualizer that provides hardware emulation for
the KVM hypervisor.

This package provides an agent to run inside guests, which communicates
with the host over a virtio-serial channel named "org.qemu.guest_agent.0"

This package does not need to be installed on the host OS.

%package -n qemu-ga-win
Summary: %{summary}

%description -n qemu-ga-win
Qemu Guest Agent for Windows

%prep
%setup -q -n qemu-%{qemu_version}
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1

%build

cp %{SOURCE1} build_configure.sh
%if %{with_vss}
   pwd
   tar -zxvf %{SOURCE2}
   ls VSSSDK72
%endif
#Build for Win32

./build_configure.sh \
   --cross-prefix=i686-w64-mingw32- \
   --enable-guest-agent-msi \
%if %{with_vss}
   --with-vss-sdk=%{_builddir}/qemu-%{qemu_version}/VSSSDK72 \
%endif
   --static || cat config.log

make qemu-ga

mkdir ../build_win32
cp qemu-ga.exe ../build_win32
cp qemu-ga-i386.msi ../build_win32

#Build for Win64

./build_configure.sh \
   --cross-prefix=x86_64-w64-mingw32- \
   --enable-guest-agent-msi \
%if %{with_vss}
   --with-vss-sdk=%{_builddir}/qemu-%{qemu_version}/VSSSDK72
%endif
   --static || cat config.log

make qemu-ga

mkdir ../build_win64
cp qemu-ga.exe ../build_win64
cp qemu-ga-x86_64.msi ../build_win64

rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{mingw32_bindir}
cp "../build_win32$MINGW_BUILDDIR_SUFFIX"/qemu-ga* $RPM_BUILD_ROOT%{mingw32_bindir}

mkdir -p $RPM_BUILD_ROOT%{mingw64_bindir}
cp "../build_win64$MINGW_BUILDDIR_SUFFIX"/qemu-ga* $RPM_BUILD_ROOT%{mingw64_bindir}

%files -n qemu-ga-win
%defattr(-,root,root)
%{mingw32_bindir}/qemu-ga*
%{mingw64_bindir}/qemu-ga*

%changelog
* Tue Jan 22 2019 Yan Vugenfirer <yvugenfi@redhat.com> 100.0.0
BZ#1651655 -  Rebase mingw-qemu-ga-win to qemu 3.1. Change the versioning scheme to independent scheme for qemu-ga-win

* Mon Dec 24 2018 Sameeh Jubran <sjubran@redhat.com> 8.0.0
BZ#1645018 - CVE-2018-12617 virtio-win: Qemu: qemu-guest-agent: Integer overflow causes segmentation fault in qmp_guest_file_read()

* Sun Dec 23 2018 Sameeh Jubran <sjubran@redhat.com> 8.0.0
BZ#1659071 [RFE]Add "windows 2019 x64" support to OS reporting

* Thu Nov 08 2018 Sameeh Jubran <sjubran@redhat.com> 8.0.0
#rebase mingw-qemu-ga-win to qemu 3.1.0

* Sun Jun 24 2018 Sameeh Jubran <sjubran@redhat.com> 7.6.0
BZ#1565431 - "Disk" is [] in the result of guest-get-fsinfo cmd which is odd
BZ#1594113 - Error returned after issue {"execute":"guest-fstrim" } cmd for win7-32/64 and win2008-32/64/r2 guest
BZ#1536331 - Failed to upgrade qemu-ga without virtio-serial driver installed

* Tue Jan 24 2018 Sameeh Jubran <sjubran@redhat.com> 7.5.0
BZ#1536954 - Issuing guest-fsfreeze-freeze cmd for the first time on a new qemu-ga,can not get response.

* Wed Dec 13 2017 Sameeh Jubran <sjubran@redhat.com> 2.9.5
- Add resolved BZs to changelog
BZ#1514303 - QEMU Guest Agent VSS Provider service is being installed with startup type: Automatic
BZ#990629 - [Windows Guest Tools] QEMU Guest Agent service failed | After post-installation reboot another reboot is needed
BZ#1514382 - [guest-agent]Still can write to freezed file system after run "{ "execute": "guest-fsfreeze-freeze"}" cmd.
BZ#1071499 - qemu guest agent for Windows should support guest-set-time command
BZ#1082999 - [WGT] Win 2008 32bit: Detected circular dependencies demand starting RHEV Spice Agent.
BZ#1470649 - [virtio-win[qemu-ga-win][upstream]]Unable to install qemu-ga on Windows platform : QEMU guest agent -- Error 1722
BZ#1514347 - [qemu-ga-win] QEMU guest agent's version is not correct.
BZ#1515137 - Error window pops up during installing windows qemu-ga-win.msi manually

* Sun Jun 04 2017 Sameeh Jubran <sjubran@redhat.com> - 2.9.0
- First release
